// Demo using DHCP and DNS to perform a web client request.
// 2011-06-08 <jc@wippler.nl>
//
// License: GPLv2

#include <EtherCard.h>

// ethernet interface mac address, must be unique on the LAN
static byte mymac[] = { 0x74,0x69,0x69,0x2D,0x30,0x31 };

byte Ethernet::buffer[900];
static uint32_t timer;

const char website[] PROGMEM = "192.168.100.3";
const char* p;
String h;
      
// called when the client request is complete
static void my_callback (byte status, word off, word len) {
  Serial.println(">>>");
  Ethernet::buffer[off+900] = 0;
  Serial.print((const char*) Ethernet::buffer + off);
  Serial.println("...");
        Serial.println();
      Serial.println("=>");
      p = ((const char*) Ethernet::buffer + off + 192);
      h = (Ethernet::buffer + off + 228);
      Serial.println(p);
      Serial.println(h);
}

// Paint example specifically for the TFTLCD breakout board.
// If using the Arduino shield, use the tftpaint_shield.pde sketch instead!
// DOES NOT CURRENTLY WORK ON ARDUINO LEONARDO

// Modified for SPFD5408 Library by Joao Lopes
// Version 0.9.2 - Rotation for Mega

// *** SPFD5408 change -- Begin
#include <SPFD5408_Adafruit_GFX.h>    // Core graphics library
#include <SPFD5408_Adafruit_TFTLCD.h> // Hardware-specific library
#include <SPFD5408_TouchScreen.h>
// *** SPFD5408 change -- End

#if defined(__SAM3X8E__)
    #undef __FlashStringHelper::F(string_literal)
    #define F(string_literal) string_literal
#endif

#define YP A3  // must be an analog pin, use "An" notation!
#define XM A2  // must be an analog pin, use "An" notation!
#define YM 9   // can be a digital pin
#define XP 8   // can be a digital pin

// Original values
//#define TS_MINX 150
//#define TS_MINY 120
//#define TS_MAXX 920
//#define TS_MAXY 940

// Calibrate values
#define TS_MINX 123
#define TS_MINY 115
#define TS_MAXX 951
#define TS_MAXY 961

// For better pressure precision, we need to know the resistance
// between X+ and X- Use any multimeter to read it
// For the one we're using, its 300 ohms across the X plate
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);

#define LCD_CS A3
#define LCD_CD A2
#define LCD_WR A1
#define LCD_RD A0
// optional
#define LCD_RESET A4

// Assign human-readable names to some common 16-bit color values:
#define  BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF


Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);

#define BOXSIZE 40
#define PENRADIUS 3
int oldcolor, currentcolor;
 uint16_t width = tft.width() - 1;
 
void drawBorder () {

  // Draw a border

  uint16_t height = tft.height() - 1;
  uint8_t border = 2;

  tft.fillScreen(BLACK);
  tft.fillRect(border, border, (width - border * 2), (height - border * 2), BLACK);
  
}

void setup () {
  Serial.begin(57600);
  Serial.println(F("\n[webClient]"));
tft.reset();
tft.begin(0x9341); // SDFP5408

  tft.setRotation(3); // Need for the Mega, please changed for your choice or rotation initial
  tft.setTextSize (7);
  tft.setTextColor(BLUE);
  drawBorder ();
  
  // Change 'SS' to your Slave Select pin, if you arn't using the default pin
  if (ether.begin(sizeof Ethernet::buffer, mymac, SS) == 0)
    Serial.println(F("Failed to access Ethernet controller"));
  if (!ether.dhcpSetup())
    Serial.println(F("DHCP failed"));

  ether.printIp("IP:  ", ether.myip);
  ether.printIp("GW:  ", ether.gwip);
  ether.printIp("DNS: ", ether.dnsip);

#if 1
  // use DNS to resolve the website's IP address
  if (!ether.dnsLookup(website))
    Serial.println("DNS failed");
    //ether.dnsip = {8,8,8,8};
#elif 2
  // if website is a string containing an IP address instead of a domain name,
  // then use it directly. Note: the string can not be in PROGMEM.
  char websiteIP[] = "192.168.100.3";
  ether.parseIp(ether.hisip, websiteIP);
#else
  // or provide a numeric IP address instead of a string
  byte hisip[] = { 192,168,100,3 };
  ether.copyIp(ether.hisip, hisip);
#endif

  ether.printIp("SRV: ", ether.hisip);
}

void loop () {
  ether.packetLoop(ether.packetReceive());
    if (millis() > timer) {
    timer = millis() + 30000;
    Serial.println();
      ether.browseUrl(PSTR("/"), "", website, my_callback);
      drawBorder();
      tft.setCursor (4, 4);
      tft.print("kotol > ");
      // p const char*
      //p.remove(2);
            tft.println(p);

            //h.remove(2);
            tft.setCursor (35, 130);
            uint16_t height = (tft.height()/2) - 1;
            tft.fillRect(0, 110, ((width - 2) * 2), (height+30), BLACK);
            tft.print("von > ");
            tft.print(" ");
            tft.print(h);
   }
}

